[![XMPP Chat](https://img.shields.io/badge/chat-on%20xmpp-blue.svg)](xmpp:disroot@chat.disroot.org?join)
[![Donate](https://img.shields.io/badge/donate-appreciation-orange.svg)](https://disroot.org/en/donate)
[![Donate LiberaPay](https://img.shields.io/badge/donate-liberapay-orange.svg)](https://liberapay.com/Disroot)

---
# Disroot app
**Disroot** provides a number of online services, most of which are linked to the user account and can be used through a native mobile client (e.g., you can access and use email from several email apps). But there are also some services that do not require login or do not yet have a specifically designed application.

**DisApp** works as a kind of digital Swiss army knife: all services are accessible from it, offering to install additional software (in case there is none already installed or configured) and providing a better experience for those which do not have a specific app through the **Android WebView** (the component that allows accessing web content within an application).

It also can be used to access all the **Disroot** services that do not require an account:
* Etherpad
* Cryptpad
* Calls
* Private bin
* Upload
* Searx

#### Supported languages:
* English
* Spanish
* French
* Italian
* Portuguese
* Dutch
* Serbian

The app may requires to install additional apps. We highly recommend to install them from [**F-Droid**](https://f-droid.org/), a free and open source app store. It can be downloaded from [here](https://f-droid.org/FDroid.apk).

---
### Licensing
[License GPLv3-only](https://git.disroot.org/Disroot/disapp/src/branch/master/LICENCE.txt)

### Device Requirements
Android 4.1 or +
6 MB free on Smartphone

---
### Privacy & Permissions<a name="privacy"></a>
This app requires access to the Internet and to external storage to be able to upload and download files.

---
### Contributors
The project is always open for contributions and accepts pull requests.
* Massimiliano
* Muppeth
* Antilopa
* Fede
* Maryjane
* Meaz
* Userdebug

---
### Resources
* DisApp: [Bugs & Issues](https://git.disroot.org/Disroot/disapp/issues)
* Disroot Project: [Web](https://disroot.org) | [Git](https://git.disroot.org/Disroot) | [Hubzilla Channel](https://hub.disroot.org/channel/disroot)
* F-Droid: [Disroot App](https://f-droid.org/en/packages/org.disroot.disrootapp/)

---
### Screenshots
![Screenshot1](app/src/main/assets/screen1.png)![Screenshot2](app/src/main/assets/screen2.png)![Screenshot3](app/src/main/assets/screen3.png)

---
### Maintainers
- [Disroot.org](https://git.disroot.org/Disroot/disapp)
